# KNotes - Third edition
Yes, another rewrite was needed. Again.

## TODO
- EASY: Add option to pin/unpin notes
- EASY: Improve mobile experience
    - Instead of dialogs, use drawers as these are easier to use on mobile.
    - Add more quick actions to the mobile bar, maybe context dependant.

- Overview page
    - Show some stats about the "vault"
    - Show upcoming tasks, once we have those
    - Show upcoming events, maybe a small calendar with a list under it?
- Ctrl+k navigation/search menu
- Support images in the text note type
- Change styling in text note type 
    - No header image by default.
    - Allow for image in header instead of gradient.
- Make term links work correctly, instead of directing to an empty page
- More text note type features
    - Code blocks
    - Lists
    - Latex
    - Modify todo item state by clicking on the indicator.
- Better text formatting in text note type
    - Allow nested formatting, such as bold and italic, to be created in any order instead of only in outer-to-inner order.
    - Allow combinations of formatted text with other text types, such as bold links.
    - Don't apply formatting in certain parts/destroy formatting in some cases, such as inside the URL part of links, or terms.
- Move notes between collections
    - What happens to properties set on notes when this is done? Do we try to migrate them and delete them otherwise, or do we keep them as is, but just ignore them unless moved back.
- Note links
- Graph page
- Calendar page
    - STRETCH: Pull ICal subscriptions into calendar data.
    - STRETCH: Caldav/calendar support. Might be easier to write a small android wrapper app that is able to sync and pull/push the data into the metadata structure.
- Todo page
    - Gather note todos into the metadata while editing
    - Gather todos from the metadata of each note, and render them in a nice list.
    - STRETCH: Allow editing of the todo state from this list. This is hard, since the client might not have the full document. To achieve this todo's might 
               need to be fully stored in the metadata with a reference to them in the editor text. Might require a sub editor or something like that.
- More collection views
    - Ability to view type per collection.
        - Maybe all options should be available and this should just be a default state?
    - Table like view
        - Allows for quick viewing editing of properties of all notes.
    - Detailed card view with certain properties shown on each note card
- STRETCH: Contacts support. Same notes as caldav support.


## Known bugs
- Offline edits in the canvas (excalidraw) note type cause all state to be lost. This might be even more severe, not requiring offline edits.


## Ideas
- Maybe rename Todos to Tasks, since they also contain doing, done, deadline, and idea types. Plus it's just a nicer name.

